<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripItemResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripItemResult_v2 extends AbstractStructArrayBase
{
    /**
     * The TripItemResult_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripItemResult_v2[]
     */
    public $TripItemResult_v2;
    /**
     * Constructor method for ArrayOfTripItemResult_v2
     * @uses ArrayOfTripItemResult_v2::setTripItemResult_v2()
     * @param \StructType\TripItemResult_v2[] $tripItemResult_v2
     */
    public function __construct(array $tripItemResult_v2 = array())
    {
        $this
            ->setTripItemResult_v2($tripItemResult_v2);
    }
    /**
     * Get TripItemResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripItemResult_v2[]|null
     */
    public function getTripItemResult_v2()
    {
        return isset($this->TripItemResult_v2) ? $this->TripItemResult_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripItemResult_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripItemResult_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripItemResult_v2ForArrayConstraintsFromSetTripItemResult_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripItemResult_v2TripItemResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripItemResult_v2TripItemResult_v2Item instanceof \StructType\TripItemResult_v2) {
                $invalidValues[] = is_object($arrayOfTripItemResult_v2TripItemResult_v2Item) ? get_class($arrayOfTripItemResult_v2TripItemResult_v2Item) : sprintf('%s(%s)', gettype($arrayOfTripItemResult_v2TripItemResult_v2Item), var_export($arrayOfTripItemResult_v2TripItemResult_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripItemResult_v2 property can only contain items of type \StructType\TripItemResult_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripItemResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_v2[] $tripItemResult_v2
     * @return \ArrayType\ArrayOfTripItemResult_v2
     */
    public function setTripItemResult_v2(array $tripItemResult_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($tripItemResult_v2ArrayErrorMessage = self::validateTripItemResult_v2ForArrayConstraintsFromSetTripItemResult_v2($tripItemResult_v2))) {
            throw new \InvalidArgumentException($tripItemResult_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($tripItemResult_v2) || (is_array($tripItemResult_v2) && empty($tripItemResult_v2))) {
            unset($this->TripItemResult_v2);
        } else {
            $this->TripItemResult_v2 = $tripItemResult_v2;
        }
        return $this;
    }
    /**
     * Add item to TripItemResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripItemResult_v2 $item
     * @return \ArrayType\ArrayOfTripItemResult_v2
     */
    public function addToTripItemResult_v2(\StructType\TripItemResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripItemResult_v2) {
            throw new \InvalidArgumentException(sprintf('The TripItemResult_v2 property can only contain items of type \StructType\TripItemResult_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripItemResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripItemResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripItemResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripItemResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripItemResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripItemResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripItemResult_v2
     */
    public function getAttributeName()
    {
        return 'TripItemResult_v2';
    }
}
